#ifndef _EXPLMAP_H_
#define _EXPLMAP_H_

typedef struct
{
    Int16    mUniverseGeometry[2],
#define      mUniverseGeometryX  mUniverseGeometry[0]
#define      mUniverseGeometryY  mUniverseGeometry[1]
             mUniverseCenter[2],
#define      mUniverseCenterX    mUniverseCenter[0]
#define      mUniverseCenterY    mUniverseCenter[1]
             mNumUsablePlanets;
}
PwrapGenConfig_Struct;

typedef struct
{
    Uns16    ScanRanges[12],
             DetectRanges[12],
             DefenseBonus[12];
    Boolean  ShareAlliedPlanets,
             ShareScannedPlanets,
             UseRandomScanning,
             SensorSweepsCount,
             DarkSenseLocates;
}
ExplMapConfig_Struct;


typedef Int16 CoordinateTuple_Def[2];

typedef struct
{
    CoordinateTuple_Def Position;
    Boolean             IsMovable;  /* spare planet */
}
XYPlan_Entry;

typedef XYPlan_Entry XYPlan_Def[501];


typedef struct
{
    Int16 X,Y,Id;
}
XYPlan_Struct;

typedef XYPlan_Struct XYPlan_Structs[PLANET_NR+1];



typedef enum
{COORD_X=0, COORD_Y=1}
XYPlan_Element;


extern PwrapGenConfig_Struct *gPwrapConfig;
extern ExplMapConfig_Struct  *gConfig;

extern const char            *gScanFileName;
extern       char            gConfigFileName[255];


extern Int32          TimChecksum[2];
extern const Int16    MinCoordinateAllowedByPlanets,
                      MaxCoordinateAllowedByPlanets,
                      DesiredDistanceFromMapEdge,
                      gVersionMajor,
                      gVersionMinor;

extern Uns16          gScannedPlanets[PLANET_NR+1];

extern XYPlan_Structs gPlanets;

extern void ExplmapConfig(void);

#endif /* #ifdef _EXPLMAP_H_ */
